<?
/* sips -- the simple, integrated publishing system
 * Copyright (C) 2000 Haakon Nilsen <haakon@nilsen.com>
 *
 * $Id: change.php,v 1.3 2001/02/04 22:28:12 haakon Exp $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

   include "../../.sipsconfig.php";
   include "../admin.inc.php";
   printTop("admin | poll | change");

   function readCounter() {
      global $config;
      $counterfile = $config["sipssys"] ."/polls/count";
      if (!file_exists($counterfile)) {
         $fp = fopen($counterfile, "w");
         fwrite($fp, "1");
      }
      $i = file($counterfile);
      return $i[0];
   }

   function writeCounter($c) {
      global $config;
      $fp = fopen($config["sipssys"] ."/polls/count", "w");
      fwrite($fp, $c);
      fclose($fp);
   }

	function printForm() {
		global $option, $question;
		print(i18n("At any given time, there can be exactly one poll on your site.") ." " .i18n("You can change that poll here. Once you have changed the poll, the former poll is archived.") ." " .i18n("You can't change the current poll, you'll have to create a new one -- so plan carefully before publishing.") ."\n");
		print("<form action=\"change.php\" method=\"post\">\n");
		print("<br>" .i18n("Question") .": <input type=\"text\" name=\"question\" value=\"$question\" size=\"40\" maxlength=\"40\"><br>\n");
		for ($i = 0; $i < count($option); $i++)
			print("<input type=\"hidden\" name=\"option[$i]\" value=\"$option[$i]\">\n");
		if (count($option) > 0) {
			print("<select name=\"remove[]\" multiple>\n");
			for ($i = 0; $i < count($option); $i++) {
				$n = $i + 1;
				print("<option value=\"$i\">$n: $option[$i]</option>\n");
			}
			print("</select>\n<br><input type=\"submit\" name=\"action\" value=\"" .i18n("Remove selected options") ."\">");
		}
		print("<br>" .i18n("Add option") .": <input type=\"text\" name=\"option[" .count($option) ."]\" size=\"40\" maxlength=\"40\"><input type=\"submit\" name=\"action\" value=\"" .i18n("Add option") ."\">\n");
		print("<br><br><input type=\"submit\" name=\"action\" value=\"" .i18n("Publish this poll") ."\">");
		print("</form>");
	}

   if (authAdmin()) {
      include $config["sipsbase"] ."/admin/menutop.inc.php";
      
      for ($i = 0; $i < count($option); $i++)
         $option[$i] = cleanStr($option[$i]);
      $question = cleanStr($question);
      
      print("<h1>Change Poll</h1>");

		if ($action == i18n("Remove selected options")) {
			for ($i = 0; $i < count($option); $i++) {
            if ($option[$i] != "") {
               $mustdie = false;
               for ($a = 0; ($a < count($remove)) && (!$mustdie); $a++)
                  if ($remove[$a] == $i)
                     $mustdie = true;
               if (!$mustdie)
                  $survivors[] = $option[$i];
            }
         }
			unset($option);
         $option = $survivors;
			printForm();
      } else

      if ($action == i18n("Publish this poll")) {
         // update counter and create directories:
         $time = getdate(time());
         $pdir = $config["sipssys"] ."/polls/" .$time["year"];
         if (!file_exists($pdir))
            if (!mkdir($pdir, 0777))
               die(i18n("There was a problem creating the directory #1#. Please check the permissions.", $pdir));
         $cnt = readCounter();
	      writeCounter(++$cnt);
	      $pdir = "$pdir/$cnt";
         if (!mkdir($pdir, 0777))
            die(i18n("There was a problem creating the directory #1#. Please check the permissions.", $pdir));

         // save as "poll" file
         $fp = fopen("$pdir/poll", "w");
         fwrite($fp, "Question::$question\n");
         $n = count($option) - 1;
         fwrite($fp, "Options::$n\n");
         for ($i = 0; $i < $n; $i++) {
            $no = $i + 1;
            fwrite($fp, "Option$no::$option[$i]\n");
         }
         fclose($fp);

         // initialize results
         for ($i = 1; $i < count($option); $i++) {
            $fp = fopen("$pdir/$i", "w");
            fwrite($fp, "0");
            fclose($fp);
         }
         $fp = fopen("$pdir/total", "w");
         fwrite($fp, "0");
         fclose($fp);
         touch("$pdir/voted");

         // now set this poll as the current:
         $fp = fopen($config["sipssys"] ."/polls/current", "w");
         $current = $time["year"] ."/$cnt";
         fwrite($fp, $current);
         fclose($fp);

         // finally, generate the static html
         $fp = fopen($config["sipssys"] ."/polls/static", "w");
         fwrite($fp, "<form action=\"pollbooth.php\" method=\"post\">\n");
         fwrite($fp, "<b>$question</b><br>\n");
         for ($i = 0; $i < count($option) - 1; $i++) {
            $no = $i + 1;
            fwrite($fp, "<input type=\"radio\" name=\"option\" value=\"$no\">" .$option[$i] ."<br>\n");
         }
         fwrite($fp, "<input type=\"submit\" name=\"action\" value=\"" .i18n("Vote") ."\"> [ <a href=\"pollbooth.php?pollid=$current\">" .i18n("Results") ."</a> | <a href=\"pollbooth.php\">" .i18n("Polls") ."</a> ]\n</form>");
         fclose($fp);

         print(i18n("The poll has been updated!"));
      } else {
			printForm();
		}
      include $config["sipsbase"] ."/admin/menubottom.inc.php";
   } else {
      printNotAdmin();
   }
   printBottom();
?>
