<?
/* sips -- the simple, integrated publishing system
 * Copyright (C) 2000 Haakon Nilsen <haakon@nilsen.com>
 *
 * $Id: addcat.php,v 1.7 2000/08/02 20:28:38 haakon Exp $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
   
   include "../../.sipsconfig.php";
   include "../admin.inc.php";
   include $config["sipssys"] ."/code/search.inc.php";
   printTop("admin | " .i18n("search") ." | " .i18n("add category"));

   function error($reason) {
      print(i18n("There was a problem creating the category (#1#).", $reason));
   }
   
   if (authAdmin()) {
      include $config["sipsbase"] ."/admin/menutop.inc.php";
      print("<h1>" .i18n("Add category to index") ."</h1>\n");
      
      $category = str_replace(" ", "_", chop(strtolower($category))); // converts blank to lowscores and to lower case
   
      if ($action == "addcat") {
         $fn = $config["sipssys"] ."/sites/" .strtolower($category);
         if (file_exists($fn)) {
            $e = i18n("Category already exists");
         } else
         if (strrpos($category, ".") != false) {
            if (!file_exists($config["sipssys"] ."/sites/" .substr($category, 0, strrpos($category, ".")))) {
               $e = i18n("There is no root for this category");
            }
         }
         if ($e == "") { // we have an error!
            if (touch($fn)) {
               if (chmod($fn, 0666)) {
                  print(i18n("Category added."));
               } else {
                  error(i18n("Unknown"));
               }
            } else {
               error(i18n("Couldn't create the data file for this category"));
            }
         } else {
            error($e);
         }
      } else {
         print("<h2>" .i18n("Add Category") ."</h2>");
         print("<p>" .i18n("Categories are added by stating the name in the format &quot;topcategory.middlecategory.bottomcategory&quot;."));
			print(" " .i18n("So to add the category &quot;linux&quot; under a category called &quot;Operating Systems&quot;, simply write &quot;operating systems.linux&quot;."));
			print(" " .i18n("Category names are case insensitive."));
         print("<p>\n<form action=\"addcat.php\" method=\"post\">\n");
         print("<input type=\"text\" name=\"category\" size=\"40\">\n");
         print("<input type=\"hidden\" name=\"action\" value=\"addcat\">\n");
         print("<input type=\"submit\" value=\"" .i18n("Add this category") ."\">\n</form>\n");
      }
      include $config["sipsbase"] ."/admin/menubottom.inc.php";
   } else {
      printNotAdmin();
   }
   printBottom();
?>
