<?
/* sips -- the simple, integrated publishing system
 * Copyright (C) 2000 Haakon Nilsen <haakon@nilsen.com>
 *
 * $Id: submissions.php,v 1.6 2000/08/02 20:28:38 haakon Exp $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
   
   include "../../.sipsconfig.php";
   include "../admin.inc.php";
   include $config["sipssys"] ."/code/search.inc.php";
	printTop("admin | " .i18n("search") ." | " .i18n("manage site submissions"));

   function getSubmittedSites() {
      global $config;
      $lines = file($config["sipsbase"] ."/admin/search/submittedsites");
      for ($i=0; $i<=count($lines); $i++) {
         $liste = split("::", $lines[$i]);
         $links[$i]["URL"] = $liste[0];
         $links[$i]["Title"] = $liste[1];
         $links[$i]["Desc"] = $liste[2];
         $links[$i]["Category"] = $liste[3];
      }
      return $links;
   }

   function rebuildSubmissions($url) {
      global $config;
      $allsites = getSubmittedSites();
      for ($i = 0; $i < count($allsites); $i++) {
         $mustdie = false;
         for ($a = 0; (($a < count($allsites)) && ($mustdie == false)); $a++)
            $mustdie = ($url == $allsites[$i]["URL"]);
         if (!$mustdie)
            $survivors[] = $allsites[$i];
      }
      unlink($config["sipsbase"] ."/admin/search/submittedsites");
      touch($config["sipsbase"] ."/admin/search/submittedsites"); // any better ways to empty a file?
      for ($i = 0; $i < count($survivors)-1; $i++)
         addSubmittedSite($survivors[$i]["Category"], $survivors[$i]["URL"], $survivors[$i]["Title"], $survivors[$i]["Desc"]);
   }

   function printSites() {
      global $category;
      $sites = getSubmittedSites();
      if ($sites[0]["URL"] != "") {
         printSiteSelectionForm("submissions.php", i18n("Process this site"), $sites, $category, "radio", "<input type=\"hidden\" name=\"action\" value=\"processit\">");
      } else {
         print(i18n("There are no sites waiting."));
      }
   }

   if (authAdmin()) {
      include $config["sipsbase"] ."/admin/menutop.inc.php";
   
      print("<h1>" .i18n("Manage site submissions") ."</h1>\n");
      if ($action == "processit") {
         if ($sites[0] != "") {
            $submsites = getSubmittedSites();
            for ($i=0; $i<=count($submsites); $i++)
               if ($submsites[$i]["URL"] == $sites[0])
                  printSubmitSiteForm("submissions.php", $submsites[$i]["URL"], $submsites[$i]["Title"], $submsites[$i]["Desc"], $submsites[$i]["Category"], i18n("Insert it now"), "<input type=\"submit\" name=\"submit\" value=\"" .i18n("Remove it") ."\">\n<input type=\"hidden\" name=\"action\" value=\"insertorremoveit\">");
         } else {
            print(i18n("You have to select a site!") ."<br>\n");
            printSites();
         }
      } else
      if ($action == "insertorremoveit") {
         if ($submit == i18n("Insert it now")) {
            addLink($category, $url, $title, $desc);
            rebuildSubmissions($url);
            print(i18n("The submission was moved into the system!"));
         } else
         if ($submit == i18n("Remove it")) {
            rebuildSubmissions($url);
            print(i18n("The submitted site has been removed and is hereby lost forever."));
         }
      } else {
         printSites();
      }
      include $config["sipsbase"] ."/admin/menubottom.inc.php";
   } else {
      printNotAdmin();
   }
   printBottom();
?>
