<?
/* sips -- the simple, integrated publishing system
 * Copyright (C) 2000 Haakon Nilsen <haakon@nilsen.com>
 *
 * $Id: edit.php,v 1.11 2000/08/20 17:45:09 haakon Exp $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
   
include "../../.sipsconfig.php";
include "../admin.inc.php";
include $config["sipssys"] ."/code/stories.inc.php";
printTop("admin | " .i18n("stories") ." | " .i18n("edit story"));
   
function removeStory($storyid) {
   global $config, $usrname;
   $success = unlink($config["sipssys"] ."/stories/$storyid/story");
   if ($success)
      if (!rmdir($config["sipssys"] ."/stories/$storyid")) $success = false;
      
   // Delete the day dir if it's empty
   $dateid = substr($storyid, 0, strrpos($storyid, "/"));
   $handle = opendir($config["sipssys"] ."/stories/$dateid");
   while ($file = readdir($handle))
      if (($file != ".") && ($file != "..")) $fno++;
   closedir($handle);
   if ($fno == 0) rmdir($config["sipssys"] ."/stories/$dateid");
      
   // Delete the month dir if it's empty
   $monthid = substr($dateid, 0, strrpos($dateid, "/"));
   $handle = opendir($config["sipssys"] ."/stories/$monthid");
   while ($file = readdir($handle))
      if (($file != ".") && ($file != "..")) $fno++;
   closedir($handle);
   if ($fno == 0) rmdir($config["sipssys"] ."/stories/$monthid");
      
   // Delete the year dir if it's empty
   $yearid = substr($monthid, 0, strrpos($monthid, "/"));
   $handle = opendir($config["sipssys"] ."/stories/$yearid");
   while ($file = readdir($handle))
      if (($file != ".") && ($file != "..")) $fno++;
   closedir($handle);
   if ($fno == 0) rmdir($config["sipssys"] ."/stories/$yearid");

   if ($success) {
      rebuildXML();
      deleteUserCache($usrname);
   }
   return $success;
}
   
   if (authAdmin()) {
      include $config["sipsbase"] ."/admin/menutop.inc.php";
      
      print("<h1>" .i18n("Edit / remove stories") ."</h1>\n");
      if (($action == "editold") && (!file_exists($config["sipssys"] ."/stories/$storyid/story"))) {
         print(i18n("There is no story with that ID. Please try again."));
         include $config["sipsbase"] ."/admin/menubottom.inc.php";
         printBottom();
         exit();
      }

      if ($submit == "Change") {
         $a = getStoryWithID($storyid);
         $fields ="<input type=\"hidden\" name=\"postedbyuser\" value=\"" .$a["PostedByUser"] ."\">\n<input type=\"hidden\" name=\"postedbyemail\" value=\"" .$a["PostedByEmail"] ."\">\n<input type=\"hidden\" name=\"time\" value=\"" .$a["Time"] ."\">\n<input type=\"hidden\" name=\"action\" value=\"republish\">\n\n<input type=\"submit\" name=\"submit\" value=\"" .i18n("Preview") ."\"><input type=\"submit\" name=\"submit\" value=\"" .i18n("Save changes") ."\">\n";
         print("<h2>" .i18n("Changing #1#", "\"" .$a["Title"] ."\"") ."</h2>\n");
      	printFilledSubmitForm($storyid, "edit.php", $a["Title"], $a["Keyword"], $a["Topic"], $a["Summary"], $a["Body"], $fields);
      } else
      if ($submit == i18n("Preview")) {
         print("<h2>" .i18n("Preview of the changes") .":</h2>");
         preview($time);
         $fields ="<input type=\"hidden\" name=\"postedbyuser\" value=\"$postedbyuser\">\n<input type=\"hidden\" name=\"postedbyemail\" value=\"$postedbyemail\">\n<input type=\"hidden\" name=\"time\" value=\"$time\">\n<input type=\"hidden\" name=\"action\" value=\"republish\">\n<input type=\"submit\" name=\"submit\" value=\"" .i18n("Preview") ."\">\n<input type=\"submit\" name=\"submit\" value=\"" .i18n("Save changes") ."\">\n";
         print("<h2>" .i18n("Changing #1#", "\"$title\"") ."</h2>\n");
      	printFilledSubmitForm($storyid, "edit.php", $title, $keyword, $topic, $summary, $body, $fields);
      } else
      if ($submit == i18n("Remove")) {
   		if (removeStory($storyid)) {
   			print(i18n("The story has been removed.") ."\n");
   		} else {
   		   print(i18n("There was a problem removing this story.") ."\n");
   		}
      } else
      if ($submit == i18n("Save changes")) {
         $a = constructStory($title, $topic, $keyword, $summary, $body);
         $a["PostedByUser"] = $postedbyuser;
         $a["PostedByEmail"] = $postedbyemail;
         $a["Time"] = $time;
      	saveStory($storyid, $a);
      	rebuildXML();
         $auth = explode(":", $HTTP_COOKIE_VARS["user"]);
         deleteUserCache($auth[0]);
   	   print(i18n("The story has been saved."));
      } else
      if (!$submit) {
         $art = getStoryIDs(20);
         if (count($art) == 0)
            print(i18n("No stories have been posted yet!"));
         else {
            print("<h2>" .i18n("Select recent story") ."</h2>\n");
            print("<form action=\"edit.php\" method=\"POST\">\n");
            print("<input type=\"hidden\" name=\"action\" value=\"editrecent\">\n");
            print("<select name=\"storyid\">\n");
            for ($i = 0; $i <= count($art) - 1; $i++) {
               $a = getStoryWithID($art[$i]);
               print("<option value=\"" .$art[$i] ."\">" .$a["Title"] ."</option>\n");
            }
            print("</select>\n<input type=\"submit\" name=\"submit\" value=\"" .i18n("Change") ."\">\n");
            print("<input type=\"submit\" name=\"submit\" value=\"" .i18n("Remove") ."\">\n</form>");
            print("<h2>" .i18n("...or type in a Story ID manually (example: #B#2000/10/23/241#/B#)") ."</h2>\n");
            print("<form action=\"edit.php\" method=\"POST\">\n");
            print("<input type=\"hidden\" name=\"action\" value=\"editold\">\n");
            print("<input type=\"text\" name=\"storyid\">\n");
            print("<input type=\"submit\" name=\"submit\" value=\"" .i18n("Change") ."\">\n");
            print("<input type=\"submit\" name=\"submit\" value=\"" .i18n("Remove") ."\">\n</form>");
      }
   }
   include $config["sipsbase"] ."/admin/menubottom.inc.php";
} else {
   printNotAdmin();
}
printBottom();
