<?
/* sips -- the simple, integrated publishing system
 * Copyright (C) 2000 Haakon Nilsen <haakon@nilsen.com>
 *
 * $Id: submissions.php,v 1.12 2001/02/04 22:28:12 haakon Exp $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

   include "../../.sipsconfig.php";
   include "../admin.inc.php";
	include $config["sipssys"] ."/code/stories.inc.php";
	printTop("admin | " .i18n("stories") ." | " .i18n("manage news submissions"));

   function getStoryAt($filename) {
      // return a story at an absolute file name
  	   if (file_exists($filename)) {
        $lines = file($filename);
        for ($i=0; $i<=count($lines); $i++) {
           $liste = split("::", $lines[$i]);
           $art[$liste[0]] = chop($liste[1]);
        }
        return $art;
  	   }
   }

   function printStoryList() {
      global $config;
      $handle = opendir($config["sipsbase"] ."/admin/stories/contrib");
      while ($file = readdir($handle)) { $f++; }
      closedir($handle);
      if ($f > 2) { // if there are submitted stories to be processed
         print("<br><p><h2>" .i18n("Waiting submissions") ."</h2>\n" .i18n("Here's a list of the headers of the news stories readers have submitted. Manage them one by one.") ."\n");
         print("<p>\n<form action=\"submissions.php\" method=\"post\">\n<select name=\"storyid\">");
         $handle=opendir($config["sipsbase"] ."/admin/stories/contrib");
         while ($file = readdir($handle)) {
            if ($file != "." && $file != "..") {
      	      $lines = file("contrib/$file");
   	         for ($i=0; $i<=6; $i++) {
                  $liste = split("::", $lines[$i]);
                  if ($liste[0] == "Title") {
                     print("<option value=\"$file\">" .stripslashes($liste[1]) ."</option>\n");
                     $title = chop($liste[1]);
   		   	   }
      		   }
            }
         }
         closedir($handle);
         print("\n</select>\n<input type=\"hidden\" name=\"action\" value=\"editcontrib\">\n<input type=\"submit\" value=\"" .i18n("Manage this entry") ."\">\n</form>");
      } else
         print("<p>" .i18n("There are currently no submissions waiting."));
   }
   
   function contribForm($a) {
      global $config, $storyid;
      $fields = "<input type=\"hidden\" name=\"action\" value=\"actioncontrib\">\n<input type=\"hidden\" name=\"postedbyemail\" value=\"" .$a["Posted-by-email"] ."\">\n<input type=\"submit\" name=\"submit\" value=\"" .i18n("Preview") ."\">\n<input type=\"submit\" name=\"submit\" value=\"" .i18n("Publish this") ."\">\n<input type=\"submit\" name=\"submit\" value=\"" .i18n("Save for later") ."\">\n<input type=\"submit\" name=\"submit\" value=\"" .i18n("Delete it") ."\">\n";
     	print("<h2>" .i18n("Prepare this message") ."</h2>\n");
     	printFilledSubmitForm($storyid, "submissions.php" ,$a["Title"], $a["Keyword"], $a["Topic"], $a["Summary"], $a["Body"], $fields);
     	
     	// comments form:
     	print("<hr><h2>" .i18n("Comment your actions") ."</h2>");
     	print("<p>" .i18n("When more than one person administers the submissions, it's sometimes useful for you to attach a comment to the story.") ." " .i18n("The comments are cumulative -- you're all editing one &quot;message&quot;.") ."</p>");
     	print("<p><b>" .i18n("If you've made changes to the story, please save them before submitting this form, or the changes will be lost.") ."</b></p>\n");
  	   print("<form action=\"submissions.php\" method=\"post\">\n");
  	   print("<textarea name=\"comments\" cols=60 rows=5>\n" .str_replace("<br>", "\r\n", stripslashes(chop($a["Comments"]))) ."</textarea>\n");
  	   print("<input type=\"hidden\" name=\"storyid\" value=\"$storyid\">\n<br>");
  	   print("<input type=\"hidden\" name=\"action\" value=\"savecomment\">\n<br>");
  	   print("<input type=\"submit\" value=\"" .i18n("Save Comments") ."\">\n");
  	   print("</form>\n");

  	   // email form:
     	if ($a["Posted-by-email"] != "") {
     	   print("<hr><h2>" .i18n("E-mail the contributor") ."</h2>");
     	   print(i18n("Please make sure the receiver address looks right."));
     	   print("<form action=\"submissions.php\" method=\"post\">\n");
     	   print("<b>" .i18n("To:") ."</b> <input type=\"text\" size=\"30\" name=\"email\" value=\"" .$a["Posted-by-email"] ."\">\n");
     	   print("<br><b>" .i18n("Subject:") ."</b> Re: " .$a["Title"] ."<br>\n");
     	   print("<b>" .i18n("Message:") ."</b><br>\n<textarea name=\"msg\" cols=60 rows=5></textarea>\n");
     	   print("<input type=\"hidden\" name=\"storyid\" value=\"$storyid\">\n");
     	   print("<input type=\"hidden\" name=\"title\" value=\"" .$a["Title"] ."\">\n");
     	   print("<input type=\"hidden\" name=\"action\" value=\"sendmail\">\n<br>");
     	   print("<input type=\"submit\" value=\"" .i18n("Send the e-mail") ."\">\n");
     	   print("</form>\n");
     	}
   }

   function cleanup($str) {
     // this function duplicates code in post.php -- so shoot me ;)
     $str = str_replace("\r\n", "<br>", $str); //changes all newlines to HTML breaklines
     $str = str_replace("<?", "&lt;?", $str);
     $str = str_replace("?>", "?&gt;", $str);
     return $str;
   }


   function saveContribStory($a) {
      global $config, $storyid;
      $oldstory = getStoryAt($config["sipsbase"] ."/admin/stories/contrib/$storyid");
   	$fp = fopen($config["sipsbase"] ."/admin/stories/contrib/$storyid", "w");
   	fwrite($fp, "Title::" .$a["Title"] ."\n");
   	fwrite($fp, "Time::" . time() . "\n");
   	if ($a["Keyword"] != "")
         fwrite($fp, "Keyword::" .$a["Keyword"] ."\n");
      fwrite($fp, "Topic::" .$a["Topic"] ."\n");
      $a["Summary"] = cleanup($a["Summary"]);
      fwrite($fp, "Summary::" .$a["Summary"] ."\n");
      if ($a["Body"] != "")
         fwrite($fp, "Body::" .cleanup($a["Body"]) ."\n");
      if ($a["Posted-by-email"] != "")
         fwrite($fp, "Posted-by-email::" .$a["Posted-by-email"] ."\n");
      if ($oldstory["Comments"] != "")
         fwrite($fp, "Comments::" .$oldstory["Comments"] ."\n");
      fclose($fp);
   }

   
   function saveComment($c, $storyid) {
     global $config;
     if ($c != "") {
       $c = str_replace("\r\n", "<br>", $c);
       $fn = $config["sipsbase"] ."/admin/stories/contrib/$storyid";
       $lines = file($fn);
     	 $fp = fopen($fn, "w");
       for ($i=0; $i<count($lines); $i++) {
         $keyval = explode("::", $lines[$i]);
      	   if ($keyval[0] != "Comments") {
               fwrite($fp, chop($lines[$i]) ."\n");
            }
         }
         fwrite($fp, "Comments::$c");
         fclose($fp);
     }
   }
   
   if (authAdmin()) {
      include $config["sipsbase"] ."/admin/menutop.inc.php";
      print("<h1>" .i18n("Manage news submissions") ."</h1>\n");
      if ($action == "editcontrib") {
         $story = getStoryAt($config["sipsbase"] ."/admin/stories/contrib/$storyid");
         contribForm($story);
      } else
      if ($action == "actioncontrib") {
         if ($submit == i18n("Preview")) {
            preview(getCurrentGMT());
            $a = constructStory($title, $topic, $keyword, $summary, $body);
            $a["Posted-by-email"] = $postedbyemail;
            contribForm($a);
         } else
      	if ($submit == i18n("Publish this")) {
      	   if (($title == "") || ($summary == "")) {
               print("<b>" .i18n("You have to fill out the fields 'Title' and 'Lead Summary'!") ."<br><br>");
            } else {
      	      publishStory($title, $keyword, $topic, $summary, $body);
   	      	print("<b>" .i18n("The story was posted!") ."</b>");
         	   if (!unlink($config["sipsbase"] ."/admin/stories/contrib/$storyid"))
   	            print("There was an error removing the submitted story from the temporary storage area. Please check your permissions.");
   	      }
      	} else
      	if ($submit == i18n("Save for later")) {
      	   $a = constructStory($title, $topic, $keyword, $summary, $body);
      	   $a["Posted-by-email"] = $postedbyemail;
      	   saveContribStory($a);
      	   print("<b>" .i18n("The story has been saved for later (still unpublished)!") ."</b>");
            contribForm(getStoryAt($config["sipsbase"] ."/admin/stories/contrib/$storyid"));
      	} else
      	if ($submit == i18n("Delete it")) {
      	   if (unlink($config["sipsbase"] ."/admin/stories/contrib/$storyid"))
         	   print("<b>" .i18n("The submitted story has been deleted!") ."</b>");
         	else
         	   print("There was a problem deleting this story from the temporary storage area!");
         	printStoryList();
      	}
      } else
      if ($action == "savecomment") {
         saveComment($comments, $storyid);
         print("<b>" .i18n("Comments were saved.") ."</b>");
         contribForm(getStoryAt($config["sipsbase"] ."/admin/stories/contrib/$storyid"));
      } else
      if ($action == "sendmail") {
         mail($email, "Re: $title", $msg, "From: $siteadmin\nReply-To: $siteadmin");
         print("<b>" .i18n("Your message has been sent.") ."</b>");
         contribForm(getStoryAt($config["sipsbase"] ."/admin/stories/contrib/$storyid"));
      } else {
         printStoryList();
      }
      include $config["sipsbase"] ."/admin/menubottom.inc.php";
   } else {
      printNotAdmin();
   }
?>

<?
   printBottom();
?>
