<?
/* sips -- the simple, integrated publishing system
 * Copyright (C) 2000 Haakon Nilsen <haakon@nilsen.com>
 *
 * $Id: index.php,v 1.12 2001/02/10 18:59:27 haakon Exp $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

   include ".sipsconfig.php";
   include $config["sipssys"] ."/code/stories.inc.php";
   include $config["sipssys"] ."/code/box.inc.php";

   function getNextTempl() {
      global $storypart;
      static $pos = 0;
      $tposb = strpos($storypart, "<STORY ", $pos) + 7;
      if ($tposb > $pos) { // there's another story element
         $tpose = strpos($storypart, ">", $tposb);
         $templ[0] = substr($storypart, $tposb, $tpose - $tposb); // template name
         $pos = $tpose + 1;
         $tpose = strpos($storypart, "</STORY>", $pos);
         $templ[1] = substr($storypart, $pos, $tpose - $pos);
         $pos = $tpose;
      }
      return $templ;
   }

   function getStoryCache() {
      global $usrname, $config, $usr, $storypart;

      $cacheFile = $config["sipssys"] ."/users/$usrname[0]/$usrname/cache";
      $time = split(" ", microtime());
      $cache_time_rnd = 300 - rand(0, 600);

      if ((!(file_exists($cacheFile))) || ((filectime($cacheFile) + $config["storycachetime"] - $time[1]) + $cache_time_rnd < 0) || (!(filesize($cacheFile)))) {
         // cache file needs updating
         $a = getStoryIDs(6);
         $i = 0;
         $st = getStoryWithID($a[0]);
         $fp = fopen($cacheFile, "w");
         $stempl = getNextTempl();
         while (($st["Topic"] != "") && ($stempl[0] != "")) {
            if (isset($sep)) {
               fwrite($fp, $sep); // there's another story, so we write a seperator
               unset($sep);
            }
            if (strpos(" " .$usr["ExcludedTopics"], $st["Topic"]) == false) { // if user wants this story
               printShortStory($fp, $st, $a[$i], $stempl[0]);
               $sep = $stempl[1];
               unset($stempl);
               $stempl = getNextTempl();
            }
            if ($stempl[0] != "") {
               $i++;
               if ($i == 6) {
                  $a = getStoryIDsBefore($a[5], 6); // loads a new chunk of 6 stories
                  $i = 0;
               }
               $st = getStoryWithID($a[$i]);
            }
         }
         fclose($fp);
      }
      return (implode("", file($cacheFile)));
   }

   function printBoxes() {
      global $config, $username, $usrname, $action, $mailtousr, $newpass;
      if ($usrname != "default") {
         if (getUserValue($usrname, "Status") == "admin") { $box = "&nbsp;&nbsp;o <a href=\"admin/index.php\">" .$config["sitename"] ." " .i18n("administration") ."</a><br>"; }
         if (file_exists($config["sipssys"] ."/users/.motd")) {
            $f = file($config["sipssys"] ."/users/.motd");
            $motd = "<p>$f[0]";
         }
         $boxtext = "$box&nbsp;&nbsp;o <a href=\"preferences.php\">" .i18n("Preferences") ."</a>";
         if ($config["registered-only-submissions"] == 1) {
            $boxtext .= "<br>&nbsp;&nbsp;o <a href=\"submit.php\">" .i18n("Submit story") ."</a>";
         }
         $boxtext .= "<br>&nbsp;&nbsp;o <a href=\"logout.php\">" .i18n("Log out") ."</a>$motd";
         printBox("$usrname", "", "", $boxtext);
      }
      $boxdata = getUserValue($usrname, "Boxes");
      if ($boxdata != "") {
         $boxes = explode(",", $boxdata);
         for ($i = 0; $i < count($boxes); $i++) {
            if (file_exists($config["sipssys"] ."/boxes/$boxes[$i]")) {
               $box = getBoxData($boxes[$i]);
               printBox($box["Title"], $box["URL"], $box["Include"], $box["HTML"], $boxes[$i]);
            } else $deprecatedboxes[] = $boxes[$i];
         }
         if (count($deprecatedboxes) > 0) {
            for ($i = 0; $i < count($deprecatedboxes); $i++) {
               $boxdata = str_replace($deprecatedboxes[$i], "", $boxdata);
            }
            $boxdata = str_replace(",,", ",", $boxdata);
            if (ereg(",\$", $boxdata)) $boxdata = substr($boxdata, 0, strlen($boxdata) - 1);
            setUserValue($usrname, "Boxes", $boxdata);
         }
      }
   }

   printTop(i18n("news"));
   $fullpage = implode("", file($config["sipssys"] ."/themes/" .$usr["Theme"] ."/frontpage"));
   $pattern = "<STORIES>(.)*<\/STORIES>";
   if (ereg($pattern, $fullpage)) {
      $st = strpos($fullpage, "<STORIES>") + 9;
      $storypart = substr($fullpage, $st, strpos($fullpage, "</STORIES>") - $st);
      $fullpage = ereg_replace($pattern, getStoryCache(), $fullpage);
   }
   if (strpos($fullpage, "#BOXES#")) {
      $pagepart = explode("#BOXES#", $fullpage);
      print($pagepart[0]);
      printBoxes();
      print($pagepart[1]);
   } else
      print($fullpage);
   printBottom();
?>
