<?
/* sips -- the simple, integrated publishing system
 * Copyright (C) 2000 Haakon Nilsen <haakon@nilsen.com>
 *
 * $Id: pollbooth.php,v 1.5 2001/02/10 18:59:27 haakon Exp $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

   include ".sipsconfig.php";
   include $config["sipssys"] ."/code/polls.inc.php";
   include $config["sipssys"] ."/code/box.inc.php";
   printTop("poll booth");

   function getNumberFromFile($filename) {
      $i = file($filename);
      return $i[0];
   }
   
   function addOneTo($filename) {
      $t = getNumberFromFile($filename) + 1;
      $fp = fopen($filename, "w");
      fwrite($fp, $t);
      fclose($fp);
      return $t;
   }
   
   function updateCounter($option) {
      global $config, $pollid, $total, $pollbase;
      addOneTo("$pollbase/$option");
      $total = addOneTo("$pollbase/total");
   }
   
   function updateStatic() {
      global $poll, $staticfile, $total, $pollbase, $config;
      $html = "<b>" .$poll["Question"] ."</b><br>\n<table>";
      for ($i = 1; $i <= $poll["Options"]; $i++) {
         $votes = getNumberFromFile("$pollbase/$i");
         $percentage = round(($votes * 100) / $total);
         $html .= "<tr><td>" .$poll["Option$i"] ."</td><td>";
         if ($percentage > 0) $html .= "<img src=\"" .$config["httpbase"] ."/gfx/polls/leftbar.gif\" width=\"4\" height=\"20\"><img src=\"" .$config["httpbase"] ."/gfx/polls/mainbar.gif\" width=\"" .$percentage * 2 ."\" height=\"20\"><img src=\"" .$config["httpbase"] ."/gfx/polls/rightbar.gif\" width=\"5\" height=\"20\">";
         $html .= " ($votes / $percentage%)</td></tr>\n";
      }
      $html .= "</table>\n<div align=\"right\"><b>" .i18n("#1# total votes.", "$total") ."</div>\n";
      $fp = fopen($staticfile, "w");
      fwrite($fp, $html);
      fclose($fp);
   }
   
   function printResults() {
      global $staticfile;
      $lines = (file_exists($staticfile)? file($staticfile) : array("Nobody has voted yet!"));
      for ($i = 0; $i < count($lines); $i++) $html .= $lines[$i] ."\n";
      printBox("Poll Results", "", "", $html);
   }
   
   function cmp($a, $b) {
      $ar = explode("/", $a);
      $ai = (int)$ar[1];
      $br = explode("/", $b);
      $bi = (int)$br[1];
      return ($ai > $bi? -1 : 1);
   }
   
   function getPollIDs($startid) {
      global $config;
      $start = explode("/", $startid);
      $startno = $start[1];
      $handle = opendir($config["sipssys"] ."/polls");
      while ($file = readdir($handle))
         if (($file != ".") && ($file != "..") && ($file != "count") && ($file != "current") && ($file != "static"))
            $years[] = $file;
      closedir($handle);
      if (count($years) > 0) rsort($years);
      $yearno = 0;
      while ((count($ids) < $config["maxhits"]) && ($yearno < count($years))) {
         $handle = opendir($config["sipssys"] ."/polls/$years[$yearno]");
         while ($file = readdir($handle))
            if (($file != ".") && ($file != "..") && ($file <= $startno))
               $temp[] = "$years[$yearno]/$file";
         closedir($handle);
         if (count($temp) > 0) {
            usort($temp, cmp);
            do {
               $id = next($temp);
               if ($id != "")
                  $ids[] = $id;
            } while ((count($ids) < $config["maxhits"]) && ($id != ""));
         }
         unset($temp);
         $yearno++;
      }
      if (count($ids) > 0) usort($ids, cmp);
      return $ids;
   }

   print("<h1>" .$config["sitename"] ." " .i18n("polls") ."</h1>\n");

   if (isset($pollid)) {
      $pollbase = $config["sipssys"] ."/polls/$pollid";
      $staticfile = "$pollbase/static";
      printResults();
      print("<p><a href=\"pollbooth.php\">" .i18n("Other poll results...") ."</a>");
   } else
   if ($action == "Vote") {
      $pollid = getCurrentPollID();
      $poll = getPoll($pollid);
      $pollbase = $config["sipssys"] ."/polls/$pollid";
      $staticfile = "$pollbase/static";
      if (($option >= 1) && ($option <= $poll["Options"]) && isset($REMOTE_ADDR)) {
         $votedfile = "$pollbase/voted";
         $voted = false;
         if (file_exists($votedfile)) {
            $already_voted = file($votedfile);
            for ($i = 0; ($i < count($already_voted)) && (!$voted); $i++)
               if (chop($already_voted[$i]) == $REMOTE_ADDR)
                  $voted = true;
         }
         if ($voted)
            print(i18n("You (or someone else at #1#) have already voted!", $REMOTE_ADDR));
         else {
            updateCounter($option);
            $fp = fopen($votedfile, "a");
            fwrite($fp, "$REMOTE_ADDR\n");
            fclose($fp);
            updateStatic();
            print(i18n("Registered your vote for option #1#.", $option) ."<br><br>");
         }
      } else {
         print(i18n("Vote illegal - not registered."));
      }
      printResults();
   } else {
      if (file_exists($config["sipssys"] ."/polls/current")) {
         $ids = getPollIDs(isset($startat)? $startat : getCurrentPollID());
         for ($i = 0; $i < count($ids); $i++) {
            $p = getPoll($ids[$i]);
            $t = explode("/", $ids[$i]);
            $thisid = $t[1];
            print("$thisid: <a href=\"pollbooth.php?pollid=$ids[$i]\">" .$p["Question"] ."</a><br>");
         }
         if (count($ids) == 0)
            print(i18n("No more polls!"));
         else {
            print("<br><a href=\"pollbooth.php\">&lt; " .i18n("First") ."</a>");
            if (count($ids) == $config["maxhits"]) print(" | <a href=\"pollbooth.php?startat=" .$ids[count($ids) - 1] ."\">" .i18n("Next") ." &gt;</a>");
         }
      } else print(i18n("No polls available."));
   }

   printBottom();
?>