<?
/* sips -- the simple, integrated publishing system
 * Copyright (C) 2000 Haakon Nilsen <haakon@nilsen.com>
 *
 * $Id: preferences.php,v 1.10 2000/08/20 17:45:09 haakon Exp $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

   include ".sipsconfig.php";
   include $config["sipssys"] ."/code/stories.inc.php";
   include $config["sipssys"] ."/code/box.inc.php";


   function printPrefsTop($title) {
      global $errmsg, $message;
      printTop($title);
      print("<h1>" .i18n("User preferences") ."</h1>\n [ <a href=\"preferences.php?op=userinfo\">" .i18n("user info") ."</a> | <a href=\"preferences.php?op=password\">" .i18n("password") ."</a> | <a href=\"preferences.php?op=topics\">" .i18n("topics") ."</a> | <a href=\"preferences.php?op=boxes\">" .i18n("boxes") ."</a> | <a href=\"preferences.php?op=theme\">" .i18n("theme") ."</a> | <a href=\"preferences.php?op=timezone\">" .i18n("timezone") ."</a> | <a href=\"preferences.php?op=cancelaccount\">" .i18n("cancel account") ."</a> ]\n<p>");
      if ($errmsg) print("<b>ERROR: $errmsg</b>\n<p>");
      if ($message) print("<b>$message</b>\n<p>");
   }
   
   function printPrefsBottom() {
      printBottom();
      exit();
   }

   function userInfo() {
      global $usrname, $usr;
      print("<h2>" .i18n("User Information") ."</h2>\n");
      print(i18n("These are your user data. To change them, fill in the new values and submit."));
      print(" " .i18n("To delete any field blank that field out and submit."));
      print("<p>\n<form action=\"preferences.php\" method=\"post\">\n<table>\n");
      print("<tr><td>" .i18n("Username") .":</td><td>$usrname (" .i18n("won't change") .")</td></tr>\n");
      print("<tr><td>" .i18n("Real Name") .":</td><td><input size=\"50\" maxlength=\"80\" type=\"text\" name=\"name\" value=\"" .chop($usr["Realname"]) ."\"> (" .i18n("Optional") .")</td></tr>\n");
      print("<tr><td>" .i18n("Real Email") .":</td><td><input size=\"50\" maxlength=\"80\" type=\"text\" name=\"email\" value=\"" .chop($usr["Email"]) ."\"> (" .i18n("#B#Required#/B# but not public. Needed if you lose your password.") .")</td></tr>\n");
      print("<tr><td>" .i18n("Fake Email") .":</td><td><input size=\"50\" maxlength=\"80\" type=\"text\" name=\"fakeemail\" value=\"" .chop($usr["FakeEmail"]) ."\"> (" .i18n("Optional and displayed publicly. Feel free to spamproof it if you want.") .")</td></tr>\n");
      print("<tr><td>" .i18n("Homepage") .":</td><td><input size=\"50\" maxlength=\"100\" type=\"text\" name=\"homepage\" value=\"" .chop($usr["Homepage"]) ."\"> (" .i18n("Optional") .")</td></tr>\n");
      print("<tr><td colspan=\"2\">" .i18n("Bio (255 char limit, optional)") .":<br>\n");
      print("<textarea wrap=\"virtual\" cols=\"50\" rows=\"5\" name=\"bio\">" .str_replace("<br>", "\r\n", $usr["Bio"]) ."</textarea>\n");
      print("</td></tr>\n</table>");
      print("<input type=\"hidden\" name=\"action\" value=\"saveuser\">\n<input type=\"hidden\" name=\"op\" value=\"userinfo\">\n<input type=\"submit\" value=\"" .i18n("Save User") ."\">\n</form>");
   }

   function password() {
      print("<h2>" .i18n("Password") ."</h2>\n");
      print("<p>" .i18n("To change your password, fill in these three fields, else leave them blank."));
      print("<p>" .i18n("You can have your password e-mailed to you, should you ever forget it.") ." " .i18n("Thus, registering an e-mail address under &quot;user info&quot; is a good thing.") ."\n");
      print("<p>" .i18n("Your password should be between 6 and (max) 12 characters long. It can consist of letters and numbers, and it is case sensitive."));
      print("<p>\n<form action=\"preferences.php\" method=\"post\">\n<table>\n");
      print("<tr><td>" .i18n("Old password") .":</td><td><input size=\"12\" maxlength=\"12\" type=\"password\" name=\"oldpass\"></td></tr>\n");
      print("<tr><td>" .i18n("New password") .":</td><td><input size=\"12\" maxlength=\"12\" type=\"password\" name=\"password\"></td></tr>\n");
      print("<tr><td>" .i18n("Repeat new password") .":</td><td><input size=\"12\" maxlength=\"12\" type=\"password\" name=\"password2\"></td></tr>\n");
      print("</table>\n<input type=\"hidden\" name=\"action\" value=\"savepassword\">\n<input type=\"hidden\" name=\"op\" value=\"password\">\n<input type=\"submit\" value=\"" .i18n("Set new password") ."\">\n</form>\n");
   }
   
   function topics() {
      global $config, $usr;
      print("<h2>" .i18n("Exclude topics") ."</h2>\n");
      $topics = getTopics();
      if (count($topics) > 1) {
         print(i18n("If there's some topics you're not interested in, you can mark them here for exclusion."));
         print(" " .i18n("This means that you won't see them on the frontpage as they are published."));
         print(" " .i18n("However, they will still be searchable like any other story at #1#.", $config["sitename"]));
         print("<form action=\"preferences.php\" method=\"post\">\n");
         print("<input type=\"hidden\" name=\"action\" value=\"savetopics\">\n");
         print("<input type=\"hidden\" name=\"op\" value=\"topics\">\n");
         print("<table cellpadding=\"3\" cellspacing=\"0\" width=\"100%\">\n");
         $dcolor = false;
         for ($i = 0; $i < count($topics); $i++) {
            $dcolor = !$dcolor;
            if ($dcolor) { $col = $config["darkmarkcolor"]; } else { $col = $config["lightmarkcolor"]; }
            if ($colno == 0) {
               print("<tr>");
            }
            print("<td width=\"33%\" bgcolor=\"$col\"><input type=\"checkbox\" name=\"extopics[]\" value=\"$topics[$i]\"");
            if (strpos(" " .$usr["ExcludedTopics"], $topics[$i]) != false) { print(" checked"); }
            print(">" .ucfirst($topics[$i]) ."</td>");
            $colno++;
            if ($colno == 3) {
               print("</tr>\n");
               $colno = 0;
            }
         }
         print("</table>\n<input type=\"submit\" value=\"" .i18n("Save topics") ."\">\n</form>\n");
      } else print(i18n("Sorry, #1# only has one topic. Kindly refusing to exclude that.", $config["sitename"]));
   }

   
   function boxes() {
      global $config, $usr;
      print("<h2>Select Boxes</h2>\n");
      $boxes = getBoxes();
      if (count($boxes) > 0) {
         print(i18n("Boxes are pieces of information shown in the right colomn on the front page."));
         print(" " .i18n("These often show the recent headlines of other news sites on the net. Turn them on or off as you like."));
         print(" " .i18n("#B#Note:#/B# You can have a maximum of 6 boxes at a time. If you select more than that here, only the six first will be saved."));
         print("<p>\n<form action=\"preferences.php\" method=\"post\">\n");
         print("<input type=\"hidden\" name=\"action\" value=\"saveboxes\">\n");
         print("<input type=\"hidden\" name=\"op\" value=\"boxes\">\n");
         print("<table cellpadding=\"3\" cellspacing=\"0\" width=\"100%\">\n");
         $dcolor = false;
         for ($i = 0; $i < count($boxes); $i++) {
            $dcolor = !$dcolor;
            if ($dcolor) { $col = $config["darkmarkcolor"]; } else { $col = $config["lightmarkcolor"]; }
            if ($colno == 0) {
               print("<tr>");
            }
            $boxdata = getBoxData($boxes[$i]);
            print("<td width=\"33%\" bgcolor=\"$col\"><input type=\"checkbox\" name=\"boxes[]\" value=\"$boxes[$i]\"");
            if (strpos(" " .$usr["Boxes"], $boxes[$i]) != false) { print(" checked"); }
            print(">" .$boxdata["Title"] ."</td>");
            $colno++;
            if ($colno == 3) {
               print("</tr>\n");
               $colno = 0;
            }
         }
         print("</table>\n<input type=\"submit\" value=\"" .i18n("Save boxes") ."\">\n</form>\n");
      } else print(i18n("Sorry, #1# has no boxes for you to select here.", $config["sitename"]));
   }
   
   function theme() {
      global $config, $usr;
      $handle = opendir($config["sipssys"] ."/themes");
      while ($file = readdir($handle))
         if (($file != ".") && ($file != "..")) $themes[] = $file;
      closedir($handle);
      $n = count($themes);
      print("<h2>" .i18n("Theme") ."</h2>\n");
      if ($n < 2) {
         print(i18n("Sorry, you can't change the theming of #1#.", $config["sitename"]));
      } else {
         print(i18n("Changing the theme of #1# lets you change the appearance of the site radically according to your needs or prererences.", $config["sitename"]) ." " .i18n("Select one of the themes below."));
         print("<form action=\"preferences.php\" method=\"post\">\n<input type=\"hidden\" name=\"op\" value=\"theme\">\n<input type=\"hidden\" name=\"action\" value=\"settheme\">\n<select name=\"themename\">\n");
         for ($i = 0; $i < $n; $i++) {
            print("<option value=\"$themes[$i]\"");
            if ($usr["Theme"] == $themes[$i]) print(" selected");
            print(">" .ucfirst($themes[$i]) ."</option>\n");
         }
         print("</select>\n<input type=\"submit\" value=\"" .i18n("Set Theme") ."\"></form>\n");
      }
   }
      
   function timezone() {
      global $usr;
      print("<h2>" .i18n("Timezone Setting") ."</h2>\n");
      print(i18n("You can have times displayed in your local timezone. Select yours here!") ."\n");
      $tzn = getZoneNames();
      print("<form action=\"preferences.php\" method=\"post\">\n<input type=\"hidden\" name=\"op\" value=\"timezone\">\n<input type=\"hidden\" name=\"action\" value=\"setzone\"><select name=\"timezone\">\n");
      for ($i = 0; $i < count($tzn); $i++) {
         print("<option value=\"$tzn[$i]\"");
         if ($usr["Timezone"] == $tzn[$i]) print(" selected");
         print(">$tzn[$i]</option>\n");
      }
      print("</select>\n<input type=\"submit\" value=\"" .i18n("Set Timezone") ."\"></form>\n");
   }
   
   function cancelAccount() {
      print("<h2>" .i18n("Account Cancellation") ."</h2>\n");
      print(i18n("If you no longer wish to keep your account with us, you can have us erase everything related to your account."));
      print("<form action=\"preferences.php\" method=\"post\">\n");
      print("<input type=\"hidden\" name=\"action\" value=\"delacc\">\n");
      print("<input type=\"hidden\" name=\"op\" value=\"cancelaccount\">\n");
      print("<input type=\"submit\" value=\"" .i18n("Delete account") ."\">\n</form>\n");
   }
   
   if ($usrname == "default") {
      header("Location: " .$config["httpbase"] ."/login.php");
      exit();
   }
   
   
   if ($op == "userinfo") {
      if ($action == "saveuser") {
         $email = cleanStr($email);
         if ($email == "")
            $errmsg = i18n("You have to set &quot;Real Email&quot; to your real e-mail address!");
         else
         if (eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*$", $email))
            setUserValue($usrname, "Email", $email);
         else $errmsg = i18n("That doesn't look like your real e-mail address! Try again - use a valid address.");
         setUserValue($usrname, "FakeEmail", cleanStr($fakeemail));
         setUserValue($usrname, "Homepage", cleanStr($homepage));
         setUserValue($usrname, "Realname", cleanStr($name));
         $bio = cleanStr(chop($bio));
         if (strlen($bio) > 255) $bio = substr($bio, 0, 255);
         $bio = htmlentities($bio);
         $bio = str_replace("\r\n", "<br>", $bio);
         setUserValue($usrname, "Bio", $bio);
         $usr = getUserValues($usrname);
         $message = i18n("You're personal settings have been updated.");
      }
      printPrefsTop(i18n("preferences") ." | " .i18n("user info"));
      userInfo();
      printPrefsBottom();
   } else
   
   if ($op == "password") {
      if ($action == "savepassword") {
         if ($password == $password2) {
            $userdata = explode(":", $HTTP_COOKIE_VARS["user"]);
            if (getUserValue($userdata[0], "Password") == md5($oldpass)) {
               $cryptpass = md5($password);
               $cryptuser = "$userdata[0]:$cryptpass";
               setcookie("user", $cryptuser, time() + ($config["cookietime"] * 86400));
               setUserValue($userdata[0], "Password", $cryptpass);
            } else $errmsg = i18n("I couldn't change your password because you didn't state the correct old password.");
         } else $errmsg = i18n("Your password wasn't updated because the password couple you entered weren't identical passwords.");
         if (!$errmsg) $message = i18n("Your new password has been set.");
      }
      printPrefsTop(i18n("preferences") ." | " .i18n("user info"));
      password();
      printPrefsBottom();
   } else
   
   if ($op == "topics") {
      if ($action == "savetopics") {
         if (count($extopics) > 0) {
            sort($extopics);
            for ($i = 0; $i < count($extopics); $i++) {
               $topicstr .= ",$extopics[$i]";
            }
            setUserValue($usrname, "ExcludedTopics", substr($topicstr, 1));
         } else {
            setUserValue($usrname, "ExcludedTopics", "");
         }
         deleteUserCache($usrname);
         $usr = getUserValues($usrname);
         $message = i18n("Your topic settings have been saved!");
      }
      printPrefsTop(i18n("preferences") ." | " .i18n("topics"));
      topics();
      printPrefsBottom();
   } else
   
   if ($op == "boxes") {
      if ($action == "saveboxes") {
         for ($i = 0; ($i < count($boxes)) && ($i < 6); $i++) {
            $boxstr .= ",$boxes[$i]";
         }
         $usr["Boxes"] = substr($boxstr, 1);
         setUserValue($usrname, "Boxes", $usr["Boxes"]);
         $message = i18n("You box settings have been saved!");
      }
      printPrefsTop(i18n("preferences") ." | " .i18n("boxes"));
      boxes();
      printPrefsBottom();
   } else
   
   if ($op == "theme") {
      if ($action == "settheme") {
         setUserValue($usrname, "Theme", $themename);
         $usr["Theme"] = $themename;
         deleteUserCache($usrname);
         $message = i18n("New theme has been set. Hope you like it!");
      }
      printPrefsTop(i18n("preferences") ." | " .i18n("theme"));
      theme();
      printPrefsBottom();
   } else
   
   if ($op == "timezone") {
      if ($action == "setzone") {
         setUserValue($usrname, "Timezone", $timezone);
         $usr["Timezone"] = $timezone;
         deleteUserCache($usrname);
         $message = i18n("Your timezone settings have been updated.");
      }
      printPrefsTop(i18n("preferences") ." | " .i18n("timezone"));
      timezone();
      printPrefsBottom();
   } else
   
   if ($op == "cancelaccount") {
      if ($action == "reallydelacc") {
         $userdata = explode(":", $HTTP_COOKIE_VARS["user"]);
         $u = $userdata[0];
         $userdir = $config["sipssys"] ."/users/$u[0]/$u";
         unlink("$userdir/user");
         deleteUserCache($userdata[0]);
         rmdir($userdir);
         setcookie("user");
         printPrefsTop(i18n("preferences") ." | " .i18n("account cancelled"));
         print("<h2>" .i18n("Account deleted") ."</h2>" .i18n("Your account has been completely erased. You're welcome to set up a new account anytime. Thanks for using #1#!", $config["sitename"]));
      } else
      if ($action == "delacc") {
         printPrefsTop(i18n("preferences") ." | " .i18n("cancel account?"));
         print("<h2>" .i18n("Really delete account?") ."</h2><form action=\"preferences.php\" method=\"post\"><input type=\"hidden\" name=\"op\" value=\"cancelaccount\"><input type=\"hidden\" name=\"action\" value=\"reallydelacc\"><input type=\"submit\" value=\"" .i18n("Yes, please.") ."\"></form><form action=\"preferences.php\" method=\"get\"><input type=\"submit\" value=\"" .i18n("No!") ."\"></form>");
      } else {
         printPrefsTop(i18n("preferences") ." | " .i18n("cancel account"));
         cancelAccount();
      }
      printPrefsBottom();
   }

   printPrefsTop(i18n("user preferences"));
   printPrefsBottom();
   
?>
