<?
/* sips -- the simple, integrated publishing system
 * Copyright (C) 2000 Haakon Nilsen <haakon@nilsen.com>
 *
 * $Id: register.php,v 1.12 2001/02/10 18:59:27 haakon Exp $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

include ".sipsconfig.php";

function printForm() {
   global $username, $email;
   print("<p>" .i18n("All fields are required."));
   print("<form action=\"register.php\" method=\"post\">\n<table>\n");
   print("<tr><td>" .i18n("Username") .":</td><td><input type=\"text\" name=\"username\" value=\"$username\" size=\"12\" maxlength=\"12\"></td></tr>\n");
   print("<tr><td>" .i18n("Password") .":</td><td><input type=\"password\" name=\"password\" size=\"12\" maxlength=\"12\"></td></tr>\n");
   print("<tr><td>" .i18n("Repeat password") .":</td><td><input type=\"password\" name=\"password2\" size=\"12\" maxlength=\"12\"></td></tr>\n");
   print("<tr><td>" .i18n("Real Email") .":</td><td><input type=\"text\" name=\"email\" size=\"20\" maxlength=\"80\" value=\"$email\"> (" .i18n("Not public. Needed if you lose your password.") .")</td></tr>\n");
   print("</table>\n<input type=\"hidden\" name=\"action\" value=\"register\">\n<input type=\"submit\" value=\"" .i18n("Register me!") ."\">\n</form>\n");
}

function errorReg($msg) {
   printTop(i18n("error registering"));
   print("$msg\n");
   printForm();
}

if ($action == "register") {
   if ($password != $password2) {
      errorReg(i18n("#B#Your two passwords don't match.#/B# Try again to be sure of the password!"));
   } else
   if ($password == "") {
      errorReg("<b>" .i18n("You have to set a password!") ."</b>\n");
   } else {
      $username = strtolower($username);
      if (strlen($username) > 12) {
         errorReg(i18n("#B#Username must be 12 characters or less!#/B#"));
      } else
      if (!eregi("^([0-9a-z])*$", $username)) {
         errorReg(i18n("#B#Username contains illegal characters!#/B# Please use only alpha-numeric characters."));
      } else
      if (file_exists($config["sipssys"] ."/users/$username[0]/$username/user")) {
         errorReg(i18n("#B#This username is already in use!#/B# Please try another one."));
      } else {
         $email = cleanStr($email);
         if ($email == "") {
            errorReg("<b>" .i18n("You have to set &quot;Real Email&quot; to your real email address!") ."</b>");
         } else
         if (!eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*$", $email)) {
            print("<b>" .i18n("That doesn't look like your real e-mail address! Try again - use a valid address.") ."</b>");
         } else { // Ok to go! Ok t-to g-g-g-ooo-oooo!
            if (!file_exists($config["sipssys"] ."/users/$username[0]")) {
               mkdir($config["sipssys"] ."/users/$username[0]", 0777);
               chmod($config["sipssys"] ."/users/$username[0]", 0777);
            }
            mkdir($config["sipssys"] ."/users/$username[0]/$username", 0777);
            touch($config["sipssys"] ."/users/$username[0]/$username/user");
            $cryptpass = md5($password);
            setUserValue($username, "Password", $cryptpass);
            setUserValue($username, "Email", $email);
            if ($config["defaultboxes"] != "") setUserValue($username, "Boxes", $config["defaultboxes"]);
            setUserValue($username, "Theme", getUserValue("default", "Theme")); // new users inherit default's theme
            setUserValue($username, "Timezone", getUserValue("default", "Timezone")); // new users inherit default's timezone
            setcookie("user", "$username:$cryptpass", time() + ($config["cookietime"] * 86400));
            printTop(i18n("register"));
            print(i18n("#B#You have been registered!#/B# Welcome to #SITENAME#. To tune the service to your liking, go to #2#preferences#3#!", "<a href=\"preferences.php\">", "</a>"));
         }
      }
   }
} else {
   printTop("register");
   print("<h1>" .i18n("Register for an account with #1#!", $config["sitename"]) ."</h1>");
   printForm();
}
printBottom();
?>
