<?
/* sips -- the simple, integrated publishing system
 * Copyright (C) 2000 Haakon Nilsen <haakon@nilsen.com>
 *
 * $Id: search.php,v 1.7 2001/02/06 19:28:39 haakon Exp $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
   
   include "../.sipsconfig.php";
   include $config["sipssys"] ."/code/search.inc.php";
   printTop("search");

   if ($config["enablesearch"] == 1) {
?>

<h1>Search</h1>

<?
if (isset($category)) {
   // We are browsing categories!
   if (file_exists($config["sipssys"] ."/sites/$category")) {

      // PRINTING CURRENT BROWSED CATEGORY PATH:
      $cats = explode(".", $category);
      for ($i=0; $i<count($cats); $i++) {
         if ($i == count($cats)-1) {
            $p = $p ."<b>" .str_replace("_", " ", ucfirst($cats[$i])) ."</b>";
         } else {
            $ca = "";
            for ($a=0; $a<=$i; $a++) {
               $ca = $ca .$cats[$a] .".";
            }
            $p = $p ."<a href=\"" .$config["httpbase"] ."/search/search.php?category=" .substr($ca, 0, strlen($ca)-1) ."\">" .ucfirst(str_replace("_", " ", $cats[$i])) ."</a> / ";
         }
      }
      print("Path: " .$p);

      // PRINTING ANY SUBCATEGORIES:
      $hascats = false;
      $handle=opendir($config["sipssys"] ."/sites");
      while ($file = readdir($handle)) {
         if (($file != ".") && ($file != "..")) {
            if (substr($file, 0, strlen($category)) == $category) { // if this category is a subcategory of the current...
               $subcat = substr($file, strlen($category)+1); // extracts the remainder of the category when the current is removed
               if ((!strpos($subcat, ".")) && ($file != $category)) { // if this is a direct subcategory (and not the current)...
                  $c = ucfirst(substr(strrchr($file, "."),1)); // extracts the utmost category and capitalizes it
                  $subcats = $subcats ."<a href=\"" .$config["httpbase"] ."/search/search.php?category=" .$file ."\">" .$c ."</a> (" .count(file($config["sipssys"] ."/sites/$file")) ."), ";
                  $hascats = true;
               }
            }
         }
      }
      closedir($handle);
      if (strlen($subcats) > 1) {
         print("<h2>" .i18n("Category hits") ."</h2>\n<table cellpadding=5 width=\"100%\"><tr bgcolor=\"" .$config["darkmarkcolor"] ."\"><td>" .substr($subcats, 0, strlen($subcats)-2) ."</td></tr></table>");
      }

      // PRINTING LINKS IN THIS CATEGORY
      $links = getLinksInCategory($category);
      $nohits = count($links);
      if ($nohits>1) {
         print("<h2>Site hits</h2>");
         print("<table cellpadding=3 cellspacing=0 width=\"100%\">");
         for($i=0; $i<count($links)-1; $i++) {
            $darkcolor = !$darkcolor;
            if ($darkcolor) { // eyecandy
               $col = $config["darkmarkcolor"];
            } else {
               $col = $config["lightmarkcolor"];
            }
            print("<tr bgcolor=" .$col ."><td><b><a href=\"" .$links[$i]["URL"] ."\">" .$links[$i]["Title"] ."</a></b><br>\n<i>" .$links[$i]["Desc"] ."</i></td></tr>\n");
         }
         print("</table>");
      } else {
         if (!$hascats) {
            // we have no subcategories and no links in this category...
            print("<p>This category appears to be empty at the moment, sorry.");
         }
      }
      print("<p><strong><a href=\"" .$config["httpbase"] ."/search/submit.php?category=" .$category ."\">" .i18n("Submit a site to this category!") ."</a></strong><br><br>");
   } else {
      print("<p>" .i18n("There's no such category."));
   }
} else if(isset($text)) {
   // We are searching free text!
   if ($text == "") {
      print(i18n("You left the search field empty!"));
   } else {
      $cathits = searchCategoriesFor($text);
      $linkhits = searchLinksFor($text);
   
      if (!$cathits) {
         // I found no better way at the moment.. suggestions? :)
      } else {
         print("<h2>" .i18n("Category hits") ."</h2>");
         print("<table cellpadding=3 cellspacing=0 width=\"100%\">");
         for($i=0; $i<count($cathits); $i++) {
            $darkcolor = !$darkcolor;
            if ($darkcolor) { // eyecandy
               $col = $config["darkmarkcolor"];
            } else {
               $col = $config["lightmarkcolor"];
            }
            print("<tr bgcolor=" .$col ."><td>&nbsp;&nbsp;&nbsp;<b><a href=\"" .$config["httpbase"] ."/search/search.php?category=" .$cathits[$i] ."\">" .ucfirst(str_replace("_", " ", str_replace(".", " / ", $cathits[$i]))) ."</a></b></td></tr>\n");
         }
         print("</table>");
      }

      if (!$linkhits) {
      } else {
         print("<h2>" .i18n("Site hits") ."</h2>");
         print("<table cellpadding=3 cellspacing=0 width=\"100%\">");
         for($i=0; $i<count($linkhits); $i++) {
            $darkcolor = !$darkcolor;
            if ($darkcolor) { // eyecandy
               $col = $config["darkmarkcolor"];
            } else {
               $col = $config["lightmarkcolor"];
            }
            print("<tr bgcolor=" .$col ."><td><b><a href=\"" .$linkhits[$i]["URL"] ."\">" .$linkhits[$i]["Title"] ."</a></b>");
            $cats = explode(".", $linkhits[$i]["Cat"]);
            print(" <small>(found in <a href=\"" .$config["httpbase"] ."/search/search.php?category=" .$linkhits[$i]["Cat"] ."\">" .ucfirst(str_replace("_", " ", $cats[count($cats)-1])) ."</a>)</small>");
            print("<br>\n<i>" .$linkhits[$i]["Desc"] ."</i></td></tr>\n");
         }
         print("</table>");
      }
      if ((!$linkhits) && (!$cathits)) {
         print(i18n("I found nothing searching for #1#.", $text));
      }
   }
}
?>

<p>
<form action="search.php">
<input type="text" name="text" value="<? print($text); ?>" width="30" maxlength="30">
<input type="submit" value="Search">
</form>

<?
   } else {
      print(i18n("Sorry, the search facilities have been disabled by the site administrator."));
   }
   printBottom();
?>
