<?
// 
// RDFPARSER 0.2 - Mike Krus  mwkrus@yahoo.com   http://mkrus.free.fr/ 
// 
// You may use this code for whatever purpose as long you keep this message 
// and don't blame me if does not work!! 
// 
// This version has been modified for use with sips
// <URL:http://sips.sourceforge.net> by Haakon Nilsen <haakon@nilsen.com>.
//
// $Id: rssparser.inc.php,v 1.3 2000/08/20 17:35:38 haakon Exp $

function writeItem($ofile, $item, $url) {
    if($item !=  "") {
        $str = ereg_replace( "&*#37;",  "'", $item);
        $str = ereg_replace( "&*#38;",  "", $str);
        $str = ereg_replace( "&*#34;",  "\"", $str);
        $str = ereg_replace( "&apos;",  "'", $str);
        if($url ==  "") $s = $str; else $s = "<a href=\"$url\">$str</a>";
        fputs($ofile,  "&nbsp;&nbsp;o $s<br>\n");
    }
}


function getNextToken($ofile) {
    static $char =  "";
    $token =  "";
    $intoken = 0;
    $intag = 0;
    while (1) {
        if($char ==  "") {
            $char = fgetc($ofile);
            if(feof($ofile)) break;
        }
        if($char ==  "\n") {
            $char =  "";
            continue;
        }
        if(($char ==  " " || $char ==  "\t") && !($intag || $intoken)) {
            $char =  "";
            continue;
        }
        if($intoken == 0) {
            if($char ==  "<") $intag = 1;
                        else $intag = 0;
            $intoken = 1;
            $token .= $char;
        } else {
            if($intag == 1) {
                $token .= $char;
                if($char ==  ">") {
                    $char =  "";
                    break;
                }
            } else {
                if($char ==  "<") break;
                $token .= $char;
            }
        }
        $char =  "";
    }
    return ltrim(chop($token));
}


function parserss($rssid, $hostname, $uri, $port = 80, $maxitems = 0) {
    global $config;

    $header_passed = 0;
    $cache = $config["cachedir"] ."/$rssid.cache";

    if(file_exists($cache)) {
        $ctime = fileMtime($cache);
        if(fileSize($cache) < 20) $ctime = -1;
    } else $ctime = -1;
    $ntime = Time();
    $dtime = $ntime - $ctime;

    $linelengh = 1024;
    $uri = urldecode($uri);

    if($dtime > $ntime || $dtime > $config["rss-cache-time"]) {
        $cfile = fopen($cache,  "w");
        $fpread = fsockopen($hostname, $port);
        if(!$fpread) {
            echo "Error connecting to $hostname!<br>\n";
            return;
        } else {
            fputs($fpread,  "GET $uri HTTP/1.0\n");
            fputs($fpread,  "User-Agent: PHP RDFParser/0.2  mkrus@free.fr\n");
            fputs($fpread,  "Host: " . $hostname .  ":80\n");
            fputs($fpread,  "Accept: */*\n\n");

            $str = fgets($fpread, $linelengh); // reads a single line from rss file
            $id = strstr($str, "404"); // file not found handling
            if($id !=  "") {
                echo  "Document <A HREF=\"http://$hostname$uri\">http://$hostname$uri</A> not found\n";
                return;
            }

            while (!feof($fpread)) {
                if ($header_passed == 1) {
                    $str = getNextToken($fpread);

                    if($str ==  "<channel>") {
                        $inchannel = 1;
                    } elseif($str ==  "</channel>") {
                        $inchannel = 0;
                        $initem = 0;
                    } elseif($str ==  "<title>") {
                        $intitle = 1;
                    } elseif($str ==  "</title>") {
                        $intitle = 0;
                    } elseif($str ==  "<item>") {
                        $ittitle = "";
                        $iturl = "";
                        if($inchannel) {
                            $inchannel = 0;
                        }
                        if($initem) {
                            writeItem($cfile, $ittitle, $iturl);
                            $itemcount++;
                        }
                        $initem = 1;
                    } elseif($str ==  "</item>" && $initem) {
                        $initem = 0;
                        writeItem($cfile, $ittitle, $iturl);
                        $itemcount++;
                    } elseif($str ==  "</a>" && $initem) {
                        $initem = 0;
                        $ittitle .= $str;
                        writeItem($cfile, $ittitle, $iturl);
                        $itemcount++;
                    } elseif($str ==  "<link>") {
                        $inlink = 1;
                    } elseif($str ==  "</link>") {
                        $inlink = 0;
                    } elseif($str ==  "<name>") {
                        $inname = 1;
                    } elseif($str ==  "</name>") {
                        $inname = 0;
                    } else {
                        if($intitle) {
                            if($inchannel) $chtitle = $str;
                            elseif($initem) $ittitle .= $str;
                        } elseif($inlink) {
                            if($inchannel) $churl = $str;
                            elseif($initem && $iturl ==  "") $iturl = $str;
                        } elseif($inname) {
                            if($initem) $ittitle .= $str;
                        }
                    }
                }
                if($maxitems > 0 && $itemcount >= $maxitems) break;
                if ($header_passed == 0) {
                    $str = ltrim(Chop(fgets($fpread, $linelengh)));
                    if(strstr($str,  "Last-Modified") !=  "") {
                        $elts = split( " ", $str);
                        $filedate =  "$elts[2]&nbsp;$elts[3]&nbsp;$elts[4] $elts[5]&nbsp;$elts[6]";
                    } elseif(strstr($str,  "Content-Length") !=  "") {
                        $str = strstr($str,  " ");
                        $filesize = (int) $str;
                    } elseif ($str ==  "") {
                        $header_passed = 1;
                    }
                }
            }
            if($filedate ==  "") {
                $ctime = fileMtime($cache);
                $filedate = Date( "G:i m/d/y", $ctime);
            }
            if($itemcount == 0) {
                fputs($cfile,  "No items found!<BR>");
            }
            fclose($fpread);
        }
        fclose($cfile);
    }
    return $cache;
}

?>