<?

// Timezone definitions (taken from slashcode)

$tz["Newfoundland Daylight"]           =  -9000;
$tz["Atlantic Daylight"]               = -10800;
$tz["Eastern Daylight"]                = -14400;
$tz["Central Daylight"]                = -18000;
$tz["Mountain Daylight"]               = -21600;
$tz["Pacific Daylight"]                = -25200;
$tz["Yukon Daylight"]                  = -28800;
$tz["Hawaii Daylight"]                 = -32400;
$tz["British Summer"]                  =   3600;
$tz["Middle European Summer"]          =   7200;
$tz["Swedish Summer"]                  =   7200;
$tz["French Summer"]                   =   7200;
$tz["West Australian Daylight"]        =  28800;
$tz["Central Australian Daylight"]     =  37800;
$tz["Eastern Australian Daylight"]     =  39600;
$tz["New Zealand Daylight"]            =  46800;
$tz["Greenwich Mean"]                  =      0;
$tz["Universal (Coordinated)"]         =      0;
$tz["Western European"]                =      0;
$tz["West Africa"]                     =  -3600;
$tz["Azores"]                          =  -7200;
$tz["Greenland Standard"]              = -10800;
$tz["Newfoundland"]                    = -12600;
$tz["Newfoundland Standard"]           = -12600;
$tz["Atlantic Standard"]               = -14400;
$tz["Eastern Standard"]                = -18000;
$tz["Central Standard"]                = -21600;
$tz["Mountain Standard"]               = -25200;
$tz["Pacific Standard"]                = -28800;
$tz["Yukon Standard"]                  = -32400;
$tz["Hawaii Standard"]                 = -36000;
$tz["Central Alaska"]                  = -36000;
$tz["Alaska-Hawaii Standard"]          = -36000;
$tz["Nome"]                            = -39600;
$tz["International Date Line West"]    = -43200;
$tz["Central European"]                =   3600;
$tz["Middle European"]                 =   3600;
$tz["Middle European Winter"]          =   3600;
$tz["Swedish Winter"]                  =   3600;
$tz["French Winter"]                   =   3600;
$tz["Eastern Europe, USSR Zone 1"]     =   7200;
$tz["Baghdad, USSR Zone 2"]            =  10800;
$tz["Iran"]                            =  12600;
$tz["USSR Zone 3"]                     =  14400;
$tz["USSR Zone 4"]                     =  18000;
$tz["Indian Standard"]                 =  19800;
$tz["USSR Zone 5"]                     =  21600;
$tz["West Australian Summer"]          =  25200;
$tz["Java"]                            =  27200;
$tz["China Coast, USSR Zone 7"]        =  28800;
$tz["Japan Standard, USSR Zone 8"]     =  32400;
$tz["Central Australian Standard"]     =  34200;
$tz["Eastern Australian Standard"]     =  36000;
$tz["New Zealand"]                     =  43200;
$tz["New Zealand Standard"]            =  43200;
$tz["International Date Line East"]    =  43200;
$tz["Israel Daylight"]                 =  10800;
$tz["Israel Standard"]                 =   7200;

$tod = gettimeofday();
$secondswest = $tod["minuteswest"] * 60;
unset($tod);

function getZoneNames() {
   // returns an array of the name of the zones
   global $tz;
   while (list($key, $val) = each($tz)) $tzn[] = $key;
   sort($tzn);
   return $tzn;
}

function getCurrentGMT() {
   global $secondswest;
	return (time() + $secondswest);
}

function serverToLocal($timestamp, $tzname) {
   // converts server time -> local (not used so far, maybe useful later...)
   global $tz, $secondswest;
   return ($timestamp + $secondswest + $tz[$tzname]);
}

function gmtToLocal($gmtstamp, $tzname) {
   // converts GMT -> local
   global $tz, $secondswest;
   return ($gmtstamp + $tz[$tzname]);
}

?>
