#!/bin/bash

# convert-to-php3: converts all references to .php files to .php3
#
# Some (most?) web hosting companies that support PHP3 only enable
# files ending with .php3 to be processed by the PHP engine.
# 
# This script converts all references to .php files to .php3
#
# Marc Nozell <marc@nozell.com>  20-April-2000
#
# Place this script in the root of the sips distro before running.

# Convert all occurrences of <a href="something.php">
#                         to <a href="something.php3"> 
find . -type f -name '*.php' -printf "perl -pi -e 's/.php\"/.php3\"/' %p\n" | sh -x

###
# There are a few files that don't end with .php, handle them.
#
find . -type f -name 'login' -printf "perl -pi -e 's/.php\"/.php3\"/' %p\n" | sh -x
find . -type f -name '.sipsconfig.php' -printf "perl -pi -e 's/.php\"/.php3\"/' %p\n" | sh -x

###
#
# Convert all occurrences of <a href="something.php?more=stuff">
#                         to <a href="something.php3?more=stuff"> 
#
find . -type f -name '*.php' -printf "perl -pi -e 's/.php\?/.php3\?/' %p\n" | sh -x

#
# There are a few files that don't end with .php, handle them.
#
find . -type f -name 'login' -printf "perl -pi -e 's/.php\?/.php3\?/' %p\n" | sh -x

###
# 
# Finally rename all the .php files to .php3
#
find . -type f -name '*.php' -printf "mv %p %p3\n" | sh -x
# Handle .sipsconfig.php
find . -type f -name '.*.php' -printf "mv %p %p3\n" | sh -x
